


function [result] = exact(alfa,beta,t,x);
  % alfa <= x < beta
  % t > 0


  l = (beta-alfa);    %
  r = (beta-alfa)/4;  %
  m = (beta+alfa)/2;  %

  if(t<0)
    disp('Error: negative time t in function exact');
  elseif(t==0)
    if(x<=m)  result=l/2;
    else      result=0;
    end;
  elseif(t<=2)
    if    (x<=alfa+l/2*t)
      result = (x-alfa)/t;
    elseif(x> alfa+l/2*t  &  x <= m+0.5*l/2*t)
      result = l/2;
    elseif(x> m+0.5*l/2*t)
      result = 0;
    end;
  elseif(t> 2)
    s = l/2 / (1+(t-2)/2);
    h = r - s/2;
    y = alfa + mod((x-alfa) - r*(t-2), beta-alfa);
    result = h + s * (y-alfa)/l;
  end;